/**
 * Copyright (C) 2013 Emerson Ribeiro de Mello e Luiz Gustavo Ender
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (C) 2013 Emerson Ribeiro de Mello e Luiz Gustavo Ender
 *
 * Este programa é software livre; você pode redistribuí-lo e/ou modificá-lo sob
 * os termos da Licença Pública Geral GNU, conforme publicada pela Free Software
 * Foundation; tanto a versão 2 da Licença como (a seu critério) qualquer versão
 * mais nova.
 *
 * Este programa é distribuído na expectativa de ser útil, mas SEM QUALQUER
 * GARANTIA; sem mesmo a garantia implícita de COMERCIALIZAÇÃO ou de ADEQUAÇÃO A
 * QUALQUER PROPÓSITO EM PARTICULAR. Consulte a Licença Pública Geral GNU para
 * obter mais detalhes.
 *
 * Você deve ter recebido uma cópia da Licença Pública Geral GNU junto com este
 * programa; se não, escreva para a Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307, USA.
 */
package frame;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JTextField;
import org.netbeans.api.visual.widget.Scene;

/**
 * Classe que é uma Qdisc do tipo Classes.
 *
 * @author Luiz Gustavo Ender
 */
public class ClassLess extends Qdisc {

    private int limit, quantum, pertub, rate, burst, latency,
            peakrate, mtu;
    private JTextField jTFlimit, jTFquantum, jTFpertub, jTFrate,
            jTFburst, jTFlatency, jTFpeakrate, jTFmtu, jTFparent;

    public ClassLess(Scene scene) {
        super(scene);
        jTFlimit = new JTextField();
        jTFquantum = new JTextField();
        jTFpertub = new JTextField();
        jTFrate = new JTextField();
        jTFburst = new JTextField();
        jTFlatency = new JTextField();
        jTFpeakrate = new JTextField();
        jTFmtu = new JTextField();
        jTFparent = new JTextField();
    }

    public int getLimit() {
        return limit;
    }

    public void setLimit(int limit) {
        this.limit = limit;
    }

    public int getQuantum() {
        return quantum;
    }

    public void setQuantum(int quantum) {
        this.quantum = quantum;
    }

    public int getPertub() {
        return pertub;
    }

    public void setPertub(int pertub) {
        this.pertub = pertub;
    }

    public int getRate() {
        return rate;
    }

    public void setRate(int rate) {
        this.rate = rate;
    }

    public int getBurst() {
        return burst;
    }

    public void setBurst(int burst) {
        this.burst = burst;
    }

    public int getLatency() {
        return latency;
    }

    public void setLatency(int latency) {
        this.latency = latency;
    }

    public int getPeakrate() {
        return peakrate;
    }

    public void setPeakrate(int peakrate) {
        this.peakrate = peakrate;
    }

    public int getMtu() {
        return mtu;
    }

    public void setMtu(int mtu) {
        this.mtu = mtu;
    }

    /**
     * Função que criar o painel de propriedades do objeto.
     *
     * @return retorna um JDialog que será o painel.
     */
    @Override
    public void geraPainelConf() {
        jDconf = new JDialog(((VisualScene) getScene()).getFrame(), true);
        jDconf.setTitle("Configurações");
        jDconf.setLayout(null);

        int y = 10;

        JLabel jLabel = new JLabel("Interface:");
        jLabel.setBounds(10, y, 60, 19);
        jDconf.add(jLabel);
        jTFiface.setText(((VisualScene) getScene()).getIface());
        jTFiface.setEditable(false);
        jTFiface.setBounds(75, y, 110, 25);
        jDconf.add(jTFiface);
        jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
        jLabel.setToolTipText("<html>"
                + "Mostra a interface de rede utilizada." + "<br>"
                + "</html>");
        jLabel.setBounds(195, y + 4, 16, 16);
        jDconf.add(jLabel);
        y = jTFiface.getY() + 25;

        if (getImagemNome().equals("qdisc_sub.png")) {
            jLabel = new JLabel("Parent:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            String p = "";
            if (parent instanceof Qdisc) {
                p = ((Qdisc) parent).getHandle();
            } else if (parent instanceof Classe) {
                p = ((Classe) parent).getClassid();
            }
            jTFparent.setDocument(new MaskField(1));
            jTFparent.setText(p);
            jTFparent.setBounds(75, y, 110, 25);
            jDconf.add(jTFparent);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define a classe/qdisc 'pai' deste componente." + "<br>"
                    + "&nbsp; - Exemplo: 1:0"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFparent.getY() + 25;
        }

        jLabel = new JLabel("Handle:");
        jLabel.setBounds(10, y, 60, 19);
        jDconf.add(jLabel);
        jTFhandle.setEditable(false);
        jTFhandle.setText(handle);
        jTFhandle.setBounds(75, y, 110, 25);
        jDconf.add(jTFhandle);
        jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
        jLabel.setToolTipText("<html>"
                + "Mostra o nome do componente." + "<br>"
                + "</html>");
        jLabel.setBounds(195, y + 4, 16, 16);
        jDconf.add(jLabel);
        y = jTFhandle.getY() + 25;

        jLabel = new JLabel("Qdisc: ");
        jLabel.setBounds(10, y, 60, 19);
        jDconf.add(jLabel);
        jTFqdisc.setText(qdisc);
        jTFqdisc.setBounds(75, y, 110, 25);
        jTFqdisc.setEditable(false);
        jDconf.add(jTFqdisc);
        jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
        jLabel.setToolTipText("<html>"
                + "Mostra tipo de disciplina de fila que será utilizado." + "<br>"
                + "</html>");
        jLabel.setBounds(195, y + 4, 16, 16);
        jDconf.add(jLabel);
        y = jTFqdisc.getY() + 25;

        if ("PFIFO".equalsIgnoreCase(qdisc)) {
            jLabel = new JLabel("Limit: ");
            jLabel.setBounds(10, y, 110, 19);
            jDconf.add(jLabel);
            jTFlimit.setDocument(new MaskField(2));
            jTFlimit.setText(Integer.toString(limit));
            jTFlimit.setBounds(75, y, 110, 25);
            jDconf.add(jTFlimit);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define o tamanho máximo da fila." + "<br>"
                    + "&nbsp; - Exemplo: 10 (em pacotes)"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFlimit.getY() + 25;

        } else if ("SFQ".equalsIgnoreCase(qdisc)) {
            jLabel = new JLabel("Quantum:");
            jLabel.setBounds(10, y, 70, 19);
            jDconf.add(jLabel);
            jTFquantum.setDocument(new MaskField(2));
            jTFquantum.setText(Integer.toString(quantum));
            jTFquantum.setBounds(75, y, 110, 25);
            jDconf.add(jTFquantum);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Determina a quantidade de pacotes removidos da fila SFQ por interação. " + "<br>"
                    + "Valor padrão 1 = maximum sized packet (MTU-sized)." + "<br>"
                    + "&nbsp; - Exemplo: 1"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFquantum.getY() + 25;

            jLabel = new JLabel("Pertub:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFpertub.setDocument(new MaskField(2));
            jTFpertub.setText(Integer.toString(pertub));
            jTFpertub.setBounds(75, y, 110, 25);
            jDconf.add(jTFpertub);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define o intervalo em segundos para a fila de algoritmo de pertubação." + "<br>"
                    + "&nbsp; - Exemplo: 10 (segundos)"
                    + "</html>");
            jLabel.setBounds(195, y, 16, 16);
            jDconf.add(jLabel);
            y = jTFpertub.getY() + 25;

        } else {
            jLabel = new JLabel("Rate:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFrate.setDocument(new MaskField(2));
            jTFrate.setText(Integer.toString(rate));
            jTFrate.setBounds(75, y, 110, 25);
            jDconf.add(jTFrate);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define a taxa máxima deste componente." + "<br>"
                    + "&nbsp; - Exemplo: 100 (kbps)"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFrate.getY() + 25;

            jLabel = new JLabel("Burst:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFburst.setDocument(new MaskField(2));
            jTFburst.setText(Integer.toString(burst));
            jTFburst.setBounds(75, y, 110, 25);
            jDconf.add(jTFburst);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define o tamanho do balde, para controlar a duração das rajadas." + "<br>"
                    + "&nbsp; - Exemplo: 1500 (bytes)"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFburst.getY() + 25;

            jLabel = new JLabel("Latency:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFlatency.setDocument(new MaskField(2));
            jTFlatency.setText(Integer.toString(latency));
            jTFlatency.setBounds(75, y, 110, 25);
            jDconf.add(jTFlatency);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define o tempo máximo que o pacote fica na fila aguardando uma ficha." + "<br>"
                    + "&nbsp; - Exemplo: 70 (ms)"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFlatency.getY() + 25;

            jLabel = new JLabel("Peakrate:");
            jLabel.setBounds(10, y, 70, 19);
            jDconf.add(jLabel);
            jTFpeakrate.setDocument(new MaskField(2));
            jTFpeakrate.setText(Integer.toString(peakrate));
            jTFpeakrate.setBounds(75, y, 110, 25);
            jDconf.add(jTFpeakrate);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define a taxa de pico máxima para as rajadas." + "<br>"
                    + "&nbsp; - Exemplo: 1000 (kbps)"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFpeakrate.getY() + 25;

            jLabel = new JLabel("Mtu:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFmtu.setDocument(new MaskField(2));
            jTFmtu.setText(Integer.toString(mtu));
            jTFmtu.setBounds(75, y, 110, 25);
            jDconf.add(jTFmtu);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define a quantidade mínimas de bytes contabilizada por pacote. Geralmente, utiliza-se MTU como 1500." + "<br>"
                    + "&nbsp; - Exemplo: 1500 (bytes)"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFmtu.getY() + 25;
        }

        JButton jBsalvar = new JButton("Salvar");
        jBsalvar.setBounds(115, y, 70, 25);
        jBsalvar.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                jBsalvar(e);
            }
        });
        jDconf.add(jBsalvar);
        y = jBsalvar.getY() + 25 + 30;

        jDconf.setBounds(1, 1, 220, y);
        jDconf.setSize(220, y);
        jDconf.setLocationRelativeTo(null);
        jDconf.setVisible(true);
    }

    /**
     * Evento do botão salvar
     *
     * @param evt evento
     */
    public void jBsalvar(ActionEvent evt) {
        handle = jTFhandle.getText();
        if (!"".equals(jTFlimit.getText())) {
            limit = Integer.parseInt(jTFlimit.getText());
        }
        if (!"".equals(jTFquantum.getText())) {
            quantum = Integer.parseInt(jTFquantum.getText());
        }
        if (!"".equals(jTFpertub.getText())) {
            pertub = Integer.parseInt(jTFpertub.getText());
        }
        if (!"".equals(jTFrate.getText())) {
            rate = Integer.parseInt(jTFrate.getText());
        }
        if (!"".equals(jTFburst.getText())) {
            burst = Integer.parseInt(jTFburst.getText());
        }
        if (!"".equals(jTFlatency.getText())) {
            latency = Integer.parseInt(jTFlatency.getText());
        }
        if (!"".equals(jTFpeakrate.getText())) {
            peakrate = Integer.parseInt(jTFpeakrate.getText());
        }
        if (!"".equals(jTFmtu.getText())) {
            mtu = Integer.parseInt(jTFmtu.getText());
        }

        if (getImagemNome().equals("qdisc_sub.png")) {
            if (!"".equals(jTFparent.getText())) {
                if (parent == null) {
                    parent = ((VisualScene) getScene()).getParent(jTFparent.getText());
                    if (parent != null) {
                        ((VisualScene) getScene()).getSCP().createConnection(parent, this);
                    }
                } else if (!jTFparent.getText().equals(parent.getLabelWidget().getLabel())) {
                    ((VisualScene) getScene()).getSRP().setEdge(((VisualScene) getScene()).getEdge(parent, this));
                    parent = ((VisualScene) getScene()).getParent(jTFparent.getText());
                    if (parent != null) {
                        ((VisualScene) getScene()).getSRP().reconnect(null, parent, true);
                    }
                }
            }
        }
        jDconf.dispose();
    }

    /**
     * Função que gera o comando TC para um objeto.
     *
     * @return retorna o comando TC.
     */
    @Override
    public String geraComandosTC() {
        String comando = "tc qdisc add dev " + ((VisualScene) getScene()).getIface();
        if (getImagemNome().equals("qdisc.png")) {
            comando = comando + " root";
        }

        if (parent != null) {
            comando = comando + " parent " + getParentString();
        }
        comando = comando + " handle " + handle + " " + qdisc.toLowerCase();

        if (qdisc.equalsIgnoreCase("PFIFO")) {
            if (limit > 0) {
                comando = comando + " limit " + limit;
            }
        } else if (qdisc.equalsIgnoreCase("SFQ")) {
            if (pertub > 0) {
                comando = comando + " perturb " + pertub;
            }
            if (quantum > 0) {
                comando = comando + " quantum " + quantum;
            }
        } else if (qdisc.equalsIgnoreCase("TBF")) {
            if (rate > 0) {
                comando = comando + " rate " + rate + "kbit";
            }
            if (burst > 0) {
                comando = comando + " burst " + burst + "kbit";
            }
            if (latency > 0) {
                comando = comando + " latency " + latency + "ms";
            }
            if (peakrate > 0) {
                comando = comando + " peakrate " + peakrate + "kbit";
            }
            if (mtu > 0) {
                comando = comando + " mtu " + mtu;
            }
        }
        return comando;
    }
}