/**
 * Copyright (C) 2013 Emerson Ribeiro de Mello e Luiz Gustavo Ender
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (C) 2013 Emerson Ribeiro de Mello e Luiz Gustavo Ender
 *
 * Este programa é software livre; você pode redistribuí-lo e/ou modificá-lo sob
 * os termos da Licença Pública Geral GNU, conforme publicada pela Free Software
 * Foundation; tanto a versão 2 da Licença como (a seu critério) qualquer versão
 * mais nova.
 *
 * Este programa é distribuído na expectativa de ser útil, mas SEM QUALQUER
 * GARANTIA; sem mesmo a garantia implícita de COMERCIALIZAÇÃO ou de ADEQUAÇÃO A
 * QUALQUER PROPÓSITO EM PARTICULAR. Consulte a Licença Pública Geral GNU para
 * obter mais detalhes.
 *
 * Você deve ter recebido uma cópia da Licença Pública Geral GNU junto com este
 * programa; se não, escreva para a Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307, USA.
 */
package frame;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import org.netbeans.api.visual.widget.Scene;

/**
 * Classe que faz o papel de uma Classe do QoS.
 *
 * @author Luiz Gustavo Ender
 */
public class Classe extends Objeto {

    private String nomClass, classid;
    private int rate, ceil, burst, cburst, prio, band;
    private Qdisc qdisc;
    private JTextField jTFiface, jTFparent, jTFclassid, jTFrate,
            jTFceil, jTFburst, jTFcburst, jTFprio, jTFnomClass;

    public Classe(Scene scene) {
        super(scene);
        nomClass = "htb";
        jTFiface = new JTextField();
        jTFparent = new JTextField();
        jTFclassid = new JTextField();
        jTFnomClass = new JTextField();
        jTFrate = new JTextField();
        jTFceil = new JTextField();
        jTFburst = new JTextField();
        jTFcburst = new JTextField();
        jTFprio = new JTextField();
    }

    public String getClassid() {
        return classid;
    }

    public void setClassid(String classid) {
        this.classid = classid;
    }

    public int getRate() {
        return rate;
    }

    public void setRate(int rate) {
        this.rate = rate;
    }

    public int getCeil() {
        return ceil;
    }

    public void setCeil(int ceil) {
        this.ceil = ceil;
    }

    public int getBurst() {
        return burst;
    }

    public void setBurst(int burst) {
        this.burst = burst;
    }

    public int getCburst() {
        return cburst;
    }

    public void setCburst(int cburst) {
        this.cburst = cburst;
    }

    public int getPrio() {
        return prio;
    }

    public void setPrio(int prio) {
        this.prio = prio;
    }

    public Qdisc getQdisc() {
        return qdisc;
    }

    public void setQdisc(Qdisc qdisc) {
        this.qdisc = qdisc;
    }

    public String getNomClass() {
        return nomClass;
    }

    public void setNomClass(String nomClass) {
        this.nomClass = nomClass;
    }

    public int getBand() {
        return band;
    }

    public void setBand(int band) {
        this.band = band;
    }

    /**
     * Função que criar o painel de propriedades do objeto.
     *
     * @return retorna um JDialog que será o painel.
     */
    @Override
    public void geraPainelConf() {
        jDconf = new JDialog(((VisualScene) getScene()).getFrame(), true);
        jDconf.setTitle("Configurações");
        jDconf.setLayout(null);

        int y = 10;

        if (nomClass.equals("prio")) {
            JLabel jLabel = new JLabel("Classid:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFclassid.setText(classid);
            jTFclassid.setEditable(false);
            jTFclassid.setBounds(75, y, 110, 25);
            jDconf.add(jTFclassid);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Mostra o nome do componente." + "<br>"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFclassid.getY() + 25;

            jLabel = new JLabel("Disciplina de fila: ");
            jLabel.setBounds(10, y, 110, 19);
            jDconf.add(jLabel);
            jTFnomClass.setText(nomClass);
            jTFnomClass.setBounds(125, y, 60, 25);
            jTFnomClass.setEditable(false);
            jDconf.add(jTFnomClass);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Mostra o tipo de disciplina de fila que será utilizado." + "<br>"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFnomClass.getY() + 25;
        } else {
            JLabel jLabel = new JLabel("Interface:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFiface.setText(((VisualScene) getScene()).getIface());
            jTFiface.setEditable(false);
            jTFiface.setBounds(75, y, 110, 25);
            jDconf.add(jTFiface);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Mostra a interface de rede utilizada." + "<br>"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFiface.getY() + 25;

            jLabel = new JLabel("Parent:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            String p = "";
            if (parent instanceof Qdisc) {
                p = ((Qdisc) parent).getHandle();
            } else if (parent instanceof Classe) {
                p = ((Classe) parent).getClassid();
            }
            jTFparent.setDocument(new MaskField(1));
            jTFparent.setText(p);
            jTFparent.setBounds(75, y, 110, 25);
            jDconf.add(jTFparent);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define a classe/qdisc 'pai' deste componente." + "<br>"
                    + "&nbsp; - Exemplo: 1:0"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFparent.getY() + 25;

            jLabel = new JLabel("Classid:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFclassid.setText(classid);
            jTFclassid.setEditable(false);
            jTFclassid.setBounds(75, y, 110, 25);
            jDconf.add(jTFclassid);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Mostra o nome do componente." + "<br>"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFclassid.getY() + 25;

            jLabel = new JLabel("Disciplina de fila: ");
            jLabel.setBounds(10, y, 110, 19);
            jDconf.add(jLabel);
            jTFnomClass.setText(nomClass);
            jTFnomClass.setBounds(125, y, 60, 25);
            jTFnomClass.setEditable(false);
            jDconf.add(jTFnomClass);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Mostra o tipo de disciplina de fila que será utilizado." + "<br>"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFnomClass.getY() + 25;

            jLabel = new JLabel("Rate:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFrate.setDocument(new MaskField(2));
            jTFrate.setText(Integer.toString(rate));
            jTFrate.setBounds(75, y, 110, 25);
            jDconf.add(jTFrate);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define a taxa máxima deste componente." + "<br>"
                    + "&nbsp; - Exemplo: 100 (kbps)"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFrate.getY() + 25;

            jLabel = new JLabel("Ceil:");
            jLabel.setBounds(10, y, 60, 19);
            jDconf.add(jLabel);
            jTFceil.setDocument(new MaskField(2));
            jTFceil.setText(Integer.toString(ceil));
            jTFceil.setBounds(75, y, 110, 25);
            jDconf.add(jTFceil);
            jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
            jLabel.setToolTipText("<html>"
                    + "Define a taxa máxima de pico deste componente." + "<br>"
                    + "&nbsp; - Exemplo: 150 (kbps)"
                    + "</html>");
            jLabel.setBounds(195, y + 4, 16, 16);
            jDconf.add(jLabel);
            y = jTFceil.getY() + 25;

            if ("class_sub.png".equals(getImagemNome())) {
                jLabel = new JLabel("Burst:");
                jLabel.setBounds(10, y, 60, 19);
                jDconf.add(jLabel);
                jTFburst.setDocument(new MaskField(2));
                jTFburst.setText(Integer.toString(burst));
                jTFburst.setBounds(75, y, 110, 25);
                jDconf.add(jTFburst);
                jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
                jLabel.setToolTipText("<html>"
                        + "Define a quantidade máxima de bytes que pode ser enviada na taxa Ceil." + "<br>"
                        + "&nbsp; - Exemplo: 150 (bytes)"
                        + "</html>");
                jLabel.setBounds(195, y + 4, 16, 16);
                jDconf.add(jLabel);
                y = jTFburst.getY() + 25;

                jLabel = new JLabel("CBurst:");
                jLabel.setBounds(10, y, 60, 19);
                jDconf.add(jLabel);
                jTFcburst.setDocument(new MaskField(2));
                jTFcburst.setText(Integer.toString(cburst));
                jTFcburst.setBounds(75, y, 110, 25);
                jDconf.add(jTFcburst);
                jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
                jLabel.setToolTipText("<html>"
                        + "Define a quantidade máxima de bytes que pode ser enviada na taxa da Interface." + "<br>"
                        + "&nbsp; - Exemplo: 150 (bytes)"
                        + "</html>");
                jLabel.setBounds(195, y + 4, 16, 16);
                jDconf.add(jLabel);
                y = jTFcburst.getY() + 25;

                jLabel = new JLabel("Prio:");
                jLabel.setBounds(10, y, 60, 19);
                jDconf.add(jLabel);
                jTFprio.setDocument(new MaskField(2));
                jTFprio.setText(Integer.toString(prio));
                jTFprio.setBounds(75, y, 110, 25);
                jDconf.add(jTFprio);
                jLabel = new JLabel(new ImageIcon(getClass().getResource("/imagens/duvida2.gif")));
                jLabel.setToolTipText("<html>"
                        + "Define a priodade desta Classe. Sendo 0 a de maior." + "<br>"
                        + "&nbsp; - Exemplo: 0"
                        + "</html>");
                jLabel.setBounds(195, y + 4, 16, 16);
                jDconf.add(jLabel);
                y = jTFprio.getY() + 25;
            }
        }
        JButton jBsalvar = new JButton("Salvar");
        jBsalvar.setBounds(115, y, 70, 25);
        jBsalvar.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                jBsalvar(e);
            }
        });
        jDconf.add(jBsalvar);
        y = jBsalvar.getY() + 25 + 30;

        jDconf.setBounds(1, 1, 220, y);
        jDconf.setSize(220, y);
        jDconf.setLocationRelativeTo(null);
        jDconf.setVisible(true);
    }

    /**
     * Evento do botão salvar
     *
     * @param evt evento
     */
    public void jBsalvar(ActionEvent evt) {
        classid = jTFclassid.getText();
        nomClass = jTFnomClass.getText();

        if (!"prio".equals(nomClass)) {
            if (!"".equals(jTFceil.getText())) {
                ceil = Integer.parseInt(jTFceil.getText());
            }
            if (!"".equals(jTFburst.getText())) {
                burst = Integer.parseInt(jTFburst.getText());
            }
            if (!"".equals(jTFcburst.getText())) {
                cburst = Integer.parseInt(jTFcburst.getText());
            }
            if (!"".equals(jTFprio.getText())) {
                prio = Integer.parseInt(jTFprio.getText());
            }
            if (!"".equals(jTFparent.getText())) {
                if (parent == null) {
                    parent = ((VisualScene) getScene()).getParent(jTFparent.getText());
                    if (parent != null) {
                        ((VisualScene) getScene()).getSCP().createConnection(parent, this);
                    }
                } else if (!jTFparent.getText().equals(parent.getLabelWidget().getLabel())) {
                    ((VisualScene) getScene()).getSRP().setEdge(((VisualScene) getScene()).getEdge(parent, this));
                    parent = ((VisualScene) getScene()).getParent(jTFparent.getText());
                    if (parent != null) {
                        ((VisualScene) getScene()).getSRP().reconnect(null, parent, true);
                    }
                }
            }
            if ((!"".equals(jTFrate.getText())) && (parent != null)) {
                if (getImagemNome().equals("class_sub.png")) {
                    int r = ((VisualScene) getScene()).calcRateDisp((Classe) parent, this);
                    int rate = Integer.parseInt(jTFrate.getText());
                    if (rate <= r) {
                        this.rate = rate;
                    } else {
                        JOptionPane.showMessageDialog(jDconf, "A soma das taxas ultrapassou a taixa disponível da classe pai " + getParentString() + ".\n"
                                + "Valor de Rate disponível: " + r,
                                "Erro", JOptionPane.ERROR_MESSAGE);
                    }
                } else {
                    rate = Integer.parseInt(jTFrate.getText());
                }
            }
        }
        jDconf.dispose();
    }

    /**
     * Função que gera o comando TC para um objeto.
     *
     * @return retorna o comando TC.
     */
    @Override
    public String geraComandosTC() {
        String comando = "tc class add dev " + ((VisualScene) getScene()).getIface();

        if (parent != null) {
            comando = comando + " parent " + getParentString() + " classid " + classid + " " + nomClass.toLowerCase();
        }
        if (rate > 0) {
            comando = comando + " rate " + rate + "kbit";
        }
        if (ceil > 0) {
            comando = comando + " ceil " + ceil + "kbit";
        }
        if (burst > 0) {
            comando = comando + " burst " + burst;
        }
        if (cburst > 0) {
            comando = comando + " cburst " + cburst;
        }
        if (prio > 0) {
            comando = comando + " prio " + prio;
        }
        return comando;
    }
}
